<i18n>
{
  "fr": {
    "serie-1": "Services et investissements publics",
    "serie-2": "Alimentation",
    "serie-3": "Biens et services privés",
    "serie-4": "Logement",
    "serie-5": "Mobilité",
    "cat-1": "Emissions moyennes d'un Français en 2019 *",
    "cat-2": "Objectif Accord de Paris **",
    "cat-3": "Emissions de vos déplacements domicile / travail",
    "km-walking": "km en marche",
    "km-bike": "km en vélo",
    "km-ebike": "km en vélo électrique",
    "km-scooter": "km en trottinette électrique",
    "km-2wheeler": "km en deux roues motorisées",
    "km-car": "km en voiture",
    "km-bus": "km en bus",
    "km-busintercity": "km en autocar - trajets intercités",
    "km-tram": "km en tramway",
    "km-train": "km en train",
    "km-rer": "km en RER / transilien",
    "km-subway": "km en métro",
    "engine": "motorisation",
    "days": "jour(s)"
  },
  "en": {
    "serie-1": "Public investments and services",
    "serie-2": "Food",
    "serie-3": "Private goods and services",
    "serie-4": "Housing",
    "serie-5": "Transportation",
    "cat-1": "Average annual emissions of a French citizen in 2019 *",
    "cat-2": "Emission target in the Paris Agreement **",
    "cat-3": "Your commuting-related emissions",
    "km-walking": "km walking",
    "km-bike": "km by bike",
    "km-ebike": "km by electrically assisted bike",
    "km-scooter": "km by electric scooter",
    "km-2wheeler": "km by motorized two-wheeler",
    "km-car": "km by car",
    "km-bus": "km by bus",
    "km-busintercity": "km by bus - Intercity travels",
    "km-tram": "km by tramway",
    "km-train": "km by train",
    "km-rer": "km by Paris suburban express railway including RER",
    "km-subway": "km by subway",
    "engine": "engine",
    "days": "day(s)"
  }
}
</i18n>

<template>
  <div>
    <highcharts ref="chart" :options="options"></highcharts>
    <b-notification :closable="false">
      <p>
      * Source
      <a
        target="_blank"
        class="link"
        href="https://www.myco2.fr/actualites/empreinte-carbone-francaise-moyenne-comment-est-elle-calculee"
      >MYCO2</a>, 2021. <em>Empreinte carbone française moyenne, comment est-elle calculée ?</em>
      </p>
      <p>
      ** Source
      <a
        target="_blank"
        class="link"
        href="https://www.carbone4.com/files/wp-content/uploads/2019/06/Publication-Carbone-4-Faire-sa-part-pouvoir-responsabilite-climat.pdf"
      >Carbone4</a>, 2019. <em>Faire sa part ? Pouvoir et responsabilité des individus,
      des entreprises et de l'État face à l'urgence climatique.</em>
      </p>
    </b-notification>
  </div>
</template>

<script>
import '@/plugins/highcharts.js'

export default {
  name: 'GHGIInformationFR',
  props: {
    userDeplacements: {
      type: Array,
      default: function () {
        return []
      }
    },
    citySize: {
      type: Number,
      default: 2
    }
  },
  data () {
    return {
      options: {
        chart: {
          type: 'bar'
        },
        title: {
          text: ''
        },
        legend: {
          reversed: true
        },
        credits: {
          enabled: false
        },
        series: [],
        xAxis: {
          categories: []
        },
        yAxis: {
          title: {
            text: ''
          }
        },
        tooltip: {
          valueSuffix: ' tCO2e'
        },
        plotOptions: {
          series: {
            stacking: 'normal',
            dataLabels: {
              enabled: true
            },
            groupPadding: 0,
            pointPadding: 0.1,
            borderWidth: 0
          }
        },
        exporting: {
          enabled: false
        }
      }
    }
  },
  methods: {
    getDeplacementLabel (commute, year) {
      let label = year + ' | ' + commute.getNbDayType1() + this.$t('days') + ': '
      if (commute.walking !== 0) {
        label += commute.walking + ' ' + this.$t('km-walking') + ', '
      }
      if (commute.bike !== 0) {
        label += commute.bike + ' ' + this.$t('km-bike') + ', '
      }
      if (commute.ebike !== 0) {
        label += commute.ebike + ' ' + this.$t('km-ebike') + ', '
      }
      if (commute.escooter !== 0) {
        label += commute.escooter + ' ' + this.$t('km-scooter') + ', '
      }
      if (commute.motorbike !== 0) {
        label += commute.motorbike + ' ' + this.$t('km-2wheeler') + ', '
      }
      if (commute.car !== 0) {
        label += commute.car + ' ' + this.$t('km-car')
        label += ' (' + commute.engine + '), '
      }
      if (commute.bus !== 0) {
        label += commute.bus + ' ' + this.$t('km-bus') + ', '
      }
      if (commute.busintercity !== 0) {
        label += commute.busintercity + ' ' + this.$t('km-busintercity') + ', '
      }
      if (commute.tram !== 0) {
        label += commute.tram + ' ' + this.$t('km-tram') + ', '
      }
      if (commute.train !== 0) {
        label += commute.train + ' ' + this.$t('km-train') + ', '
      }
      if (commute.expressrailway !== 0) {
        label += commute.expressrailway + ' ' + this.$t('km-rer') + ', '
      }
      if (commute.subway !== 0) {
        label += commute.subway + ' ' + this.$t('km-subway') + ', '
      }
      label = label.slice(0, -2)
      if (commute.hasWorkingDay2) {
        label += ' | ' + commute.nWorkingDay2 + this.$t('days') + ': '
        if (commute.walking2 !== 0) {
          label += commute.walking2 + ' ' + this.$t('km-walking') + ', '
        }
        if (commute.bike2 !== 0) {
          label += commute.bike2 + ' ' + this.$t('km-bike') + ', '
        }
        if (commute.ebike2 !== 0) {
          label += commute.ebike2 + ' ' + this.$t('km-ebike') + ', '
        }
        if (commute.escooter2 !== 0) {
          label += commute.escooter2 + ' ' + this.$t('km-scooter') + ', '
        }
        if (commute.motorbike2 !== 0) {
          label += commute.motorbike2 + ' ' + this.$t('km-2wheeler') + ', '
        }
        if (commute.car2 !== 0) {
          label += commute.car2 + ' ' + this.$t('km-car')
          label += ' (' + commute.engine2 + '), '
        }
        if (commute.bus2 !== 0) {
          label += commute.bus2 + ' ' + this.$t('km-bus') + ', '
        }
        if (commute.busintercity2 !== 0) {
          label += commute.busintercity2 + ' ' + this.$t('km-busintercity') + ', '
        }
        if (commute.tram2 !== 0) {
          label += commute.tram + ' ' + this.$t('km-tram') + ', '
        }
        if (commute.train2 !== 0) {
          label += commute.train2 + ' ' + this.$t('km-train') + ', '
        }
        if (commute.expressrailway2 !== 0) {
          label += commute.expressrailway2 + ' ' + this.$t('km-rer') + ', '
        }
        if (commute.subway2 !== 0) {
          label += commute.subway2 + ' ' + this.$t('km-subway') + ', '
        }
      }
      return label
    },
    setData () {
      this.options.series = [
        {
          name: this.$t('serie-1'),
          data: [1.4, 0.3],
          color: '#beab9d'
        }, {
          name: this.$t('serie-2'),
          data: [2.35, 0.6],
          color: '#f5a342'
        }, {
          name: this.$t('serie-3'),
          data: [1.6, 0.6],
          color: '#92a542'
        }, {
          name: this.$t('serie-4'),
          data: [1.9, 0.2],
          color: '#80c1f5'
        }, {
          name: this.$t('serie-5'),
          data: [2.65, 0.3],
          color: '#00507f'
        }
      ]
      this.options.xAxis.categories = [this.$t('cat-1'), this.$t('cat-2')]
      for (let dept of this.userDeplacements) {
        let intensity = dept.commute.getTotalIntensity(dept.year, this.citySize).intensity
        this.options.series[0].data.push(0)
        this.options.series[1].data.push(0)
        this.options.series[2].data.push(0)
        this.options.series[3].data.push(0)
        this.options.series[4].data.push(Math.round((intensity / 1000) * 100) / 100)
        this.options.xAxis.categories.push(this.getDeplacementLabel(dept.commute, dept.year))
      }
    }
  },
  watch: {
    '$i18n.locale': function () {
      this.setData()
    }
  },
  mounted () {
    this.setData()
  }
}
</script>
